
#include <string.h>
#include <stdio.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>

#ifndef SEEK_SET  
#define SEEK_SET 0
#define SEEK_CUR 1
#define SEEK_END 2
#endif

#include "config.h"

#ifdef BINARIES		/* Skip this entire file if BINARIES not defined */
#include "patchlevel.h"
#include "lint.h"
#include "binaries.h"
#include "interpret.h"
#include "object.h"
#include "exec.h"
#include "mapping.h"


#define align(x) ( ((x) + (sizeof(void*)-1) )  &  ~(sizeof(void*)-1) )

extern int driver_mtime;
extern int comp_flag;
FILE *crdir_fopen(char *);

int 
save_binary(prog)
struct program *prog;
{
    unsigned short flg;
    char *t;
    int ino;
    int i;
    struct program *p = prog;
    extern int driver_mtime;
    char *binname;
    extern struct object *master_ob;
    extern char *add_slash(char *);
    FILE *fout;
    
    if (master_ob)
    {
	char *tmp;
	struct svalue *ret;
	
	push_string(tmp = add_slash(prog->name), STRING_MALLOC);
	free(tmp);
	ret = apply_master_ob("valid_save_binary", 1);
	if (ret && ret->type == T_NUMBER && ret->u.number)
	{
	    binname = (char *)xalloc(strlen(BINARIES) + 
				     strlen(prog->name) + 1);
	    sprintf(binname, "%s%s", BINARIES, prog->name);
	    
	    if ((fout = crdir_fopen(binname)) != NULL)
	    {
		fwrite(MAGIC, sizeof(char), strlen(MAGIC), fout);
		fwrite((char *)&driver_mtime, sizeof(driver_mtime), 1, fout);
		
		/* now the program */
		p = prog;
		ino = strlen(p->name);
		fwrite((char *) &ino,sizeof(ino),1,fout);
		fwrite(p->name, sizeof(char), ino, fout);
		
		fwrite((char *) &p->program_size, sizeof(p->program_size), 1, fout);
		fwrite(p->program, sizeof(char), p->program_size, fout);
		fwrite((char *)&p->flags, sizeof(p->flags), 1, fout);
		load_lineno_from_swap(p);
		fwrite((char *) &p->sizeof_line_numbers,
		       sizeof(p->sizeof_line_numbers), 1, fout);
		fwrite((char *) &p->num_relocs,
		       sizeof(p->num_relocs), 1, fout);
		
		fwrite((char *) p->line_numbers, sizeof(char),
		       align(p->sizeof_line_numbers) +
		       align(p->num_relocs * sizeof(struct reloc)), fout);
		swap_lineno(p);
		
		fwrite((char *) &p->num_functions, sizeof(p->num_functions), 1, fout);
		
		
		for(i = 0; i < (int)p->num_functions; i++) 
		{
		    ino = strlen(p->functions[i].name);
		    fwrite((char *) &ino, sizeof(ino), 1, fout);
		    fwrite(p->functions[i].name, sizeof(char), ino, fout);
		    fwrite((char *) &p->functions[i].offset,
			   sizeof(p->functions[i].offset), 1, fout);
		    fwrite((char *) &p->functions[i].type_flags,
			   sizeof(p->functions[i].type_flags), 1, fout);
		    fwrite((char *) &p->functions[i].num_local,
			   sizeof(p->functions[i].num_local), 1, fout);
		    fwrite((char *) &p->functions[i].num_arg,
			   sizeof(p->functions[i].num_arg), 1, fout);
		    fwrite((char *) &p->functions[i].next_hashed_function,
			   sizeof(p->functions[i].next_hashed_function), 1, fout);
		}
		
		/* write the (future) argument_types & type_starts. is it correct ?? */
		ino = (p->argument_types) ? p->sizeof_argument_types : 0;
		fwrite((char *) &ino, sizeof(ino), 1, fout);
		if (ino)
		    fwrite((char *) p->argument_types, sizeof(char), ino, fout);
		
		if (p->type_start)
		{
		    /* what does unsigned short *type_start point to ?
		     * is this an array of num_functions NORMAL pointers
		     * into argument_types, or is it an array of 16-bit-values
		     * that point into argument_types ??? change code below
		     * uhm... i assume it points to 16bitvalues .... see exec.h
		     */
		    ino = 1;
		    fwrite((char *) &ino,sizeof(ino), 1, fout);
		    fwrite((char *) p->type_start, sizeof(unsigned short),
			   p->num_functions, fout);
		} 
		else 
		{
		    ino = 0;
		    fwrite((char *) &ino, sizeof(ino), 1, fout);
		}
		
		fwrite((char *) &p->num_strings, sizeof(p->num_strings), 1, fout);
		for(i = 0; i < (int)p->num_strings; i++) 
		{
		    ino = strlen(p->strings[i]);
		    fwrite((char *) &ino, sizeof(ino), 1, fout);
		    fwrite(p->strings[i], sizeof(char), ino, fout);
		}
		
		fwrite((char *) &p->num_variables, sizeof(p->num_variables), 1, fout);
		for(i = 0; i < (int)p->num_variables; i++)
		{
		    ino = strlen(p->variable_names[i].name);
		    fwrite((char *) &ino, sizeof(ino), 1, fout);
		    fwrite(p->variable_names[i].name, sizeof(char), ino, fout);
		    fwrite((char *) &p->variable_names[i].type,
			   sizeof(p->variable_names[i].type), 1, fout);
		}

		fwrite((char *) &p->num_inherited, sizeof(p->num_inherited), 1, fout);
		for(i = 0; i < (int)p->num_inherited; i++)
		{
		    char buf[1024];
		    sprintf(buf, "%ld:%s", p->inherit[i].prog->mod_time,
			    p->inherit[i].prog->name);
		    ino = strlen(buf);
		    fwrite((char *) &ino, sizeof(ino), 1, fout);
		    fwrite(buf, sizeof(char), ino, fout);
		    fwrite((char *) &p->inherit[i].type,
			   sizeof(p->inherit[i].type), 1, fout);
		    fwrite((char *) &p->inherit[i].variable_index_offset,
			   sizeof(p->inherit[i].variable_index_offset), 1, fout);
		    ino = strlen(p->inherit[i].name);
		    fwrite((char *) &ino, sizeof(ino), 1, fout);
		    fwrite(p->inherit[i].name, sizeof(char), ino, fout);
		}

		fwrite((char *) &p->total_size, sizeof(p->total_size), 1, fout);
		
		fwrite((char *) &p->sizeof_include_files,
		       sizeof(p->sizeof_include_files), 1, fout);
		fwrite(p->include_files, sizeof(char), p->sizeof_include_files, fout);
		fwrite((char *)&p->mod_time, sizeof(p->mod_time), 1, fout);
		
		fclose(fout);
	    free(binname);
	    return p->mod_time;
	    }
	    free(binname);
	}
    }
    return 0;
}


/*  Frees some structures of a program, if load_blib_object() fails
 */

void 
drop_prog(p)
    struct program *p;
{
    int i;
    
    if (p->name)
	free((char*) p->name);
    if (p->program)
	free((char*) p->program);
    if (p->line_numbers)
	free((char*) p->line_numbers);
    if (p->functions)
    {
	for(i = 0; i < (int)p->num_functions; i++) 
	    free_string(p->functions[i].name);
	free((char*) p->functions);
    }
    if (p->argument_types)
	free((char*) p->argument_types);
    if (p->type_start)
	free((char*) p->type_start);
    if (p->strings) 
    {
	for(i = 0; i < (int)p->num_strings; i++) 
	    free_string(p->strings[i]);
	free((char*) p->strings);
    }
    if (p->variable_names) 
    {
	for(i = 0; i < (int)p->num_variables; i++) 
	    free_string(p->variable_names[i].name);
	free((char*) p->variable_names);
    }
    if (p->inherit) 
    {
	for(i = 0; i < (int)p->num_inherited; i++)
	    free_string(p->inherit[i].name);
	free((char*) p->inherit);
    }
    if (p->sizeof_include_files) 
	free((char*) p->include_files);
}

int 
load_binary(fin, lname)
FILE *fin;
char *lname;
{
    struct object o,*tmpo;
    struct program p;
    char *tp;
    unsigned lsize;
    extern int total_prog_block_size;
    extern int total_num_prog_blocks;
    extern int total_program_size;
    
    /* these parameters are passed BACK to load_object() 
     */
    extern struct program *prog;
    extern int total_lines;   /* not used */
    extern char *inherit_file;
    extern driver_mtime;
    int comp_driver_mtime;

    long int loaded_size;
    int my_memsize, my_pmemsize;
    int ino, i, fail, buf_size;
    char *buf;



#define ALLOCATE_BUF(size) (((size) > buf_size) ? (free(buf),buf = xalloc(size)) : buf)

    buf = xalloc(buf_size = 64);
    total_lines		= 0;
    prog		= (struct program *)0;
    
    p.ref		= 0;
    p.name		= (char *)0;
    p.program		= (char *)0;
    p.line_numbers	= (unsigned short *)0;
    p.functions		= (struct function *)0;
    p.strings		= (char **)0;
    p.variable_names	= (struct variable *)0;
    p.inherit		= (struct inherit *)0;
    p.argument_types	= (unsigned short *)0;
    p.type_start	= (unsigned short *)0;
    p.include_files	= (char *)0;
    p.cpu		= 0;
    p.swap_lineno_index = 0;
    p.reloc             = 0;
    p.swap_num          = 0;
    
    if (inherit_file)
    {
	free(inherit_file);
	inherit_file	= (char *)0;
    }

    loaded_size = ftell(fin);
    
    fread(buf, sizeof(char), strlen(MAGIC), fin);
    if(strncmp(MAGIC, buf, 4))
    {
	fclose(fin);
	free(buf);
	return LIB_NOT_MAGIC;
    }
    fread((char *)&comp_driver_mtime, sizeof(comp_driver_mtime), 1, fin);
    
    if(comp_driver_mtime != driver_mtime)
    {
	fclose(fin);
	free(buf);
	return LIB_NOT_MAGIC;
    }
    
    fread((char *) &ino, sizeof(ino), 1, fin);
    ALLOCATE_BUF(ino + 1);
    fread(buf, sizeof(char), ino, fin);
    buf[ino] = '\000';

    if (strcmp(lname, buf)) 
    {
	fclose(fin);
	return LIB_LOAD_PROG;
    }
    p.name = string_copy(buf);
    
    fread((char *) &p.program_size,sizeof(p.program_size),1,fin);
    if (p.program_size) 
	p.program = xalloc(p.program_size);
    fread(p.program, sizeof(char), p.program_size, fin);
    
    fread((char *)&p.flags, sizeof(p.flags), 1, fin);
    fread((char *) &p.sizeof_line_numbers,
	  sizeof(p.sizeof_line_numbers), 1, fin);
    fread((char *) &p.num_relocs,
	  sizeof(p.num_relocs), 1, fin);
    if (p.sizeof_line_numbers || p.num_relocs) 
	{
	    p.line_numbers = (unsigned short *)
		xalloc(lsize = align(p.sizeof_line_numbers) +
		       align(p.num_relocs * sizeof(struct reloc)));
	    p.reloc = (struct reloc *)((char *)p.line_numbers +
				       align(p.sizeof_line_numbers));
	    
	    fread((char *) p.line_numbers, sizeof(char), lsize, fin);
	}
    
    fread((char *) &p.num_functions, sizeof(p.num_functions), 1, fin);

    if (p.num_functions) 
	p.functions = (struct function *) xalloc(sizeof(struct function) *
				  p.num_functions);

    for(i = 0; i < (int)p.num_functions; i++) 
    {
	fread((char *) &ino, sizeof(ino), 1, fin);
	ALLOCATE_BUF(ino + 1);
	fread(buf, sizeof(char), ino, fin);
	buf[ino] = '\000';
	p.functions[i].name = make_shared_string(buf);
	fread((char *) &p.functions[i].offset,
	      sizeof(p.functions[i].offset), 1, fin);
	fread((char *) &p.functions[i].type_flags,
	      sizeof(p.functions[i].type_flags), 1, fin);
	fread((char *) &p.functions[i].num_local,
	      sizeof(p.functions[i].num_local), 1, fin);
	fread((char *) &p.functions[i].num_arg,
	      sizeof(p.functions[i].num_arg), 1, fin);
	fread((char *) &p.functions[i].next_hashed_function,
	      sizeof(p.functions[i].next_hashed_function), 1, fin);

#ifdef PROFILE_FUNS
	p.functions[i].num_calls = 0;
	p.functions[i].time_spent = 0;
#ifdef SOLARIS
	p.functions[i].ticks_call = 0;
#else
	p.functions[i].stime_call = 0;
	p.functions[i].utime_call = 0;
#endif
#endif

    }
    
    fread((char *) &p.sizeof_argument_types,
	  sizeof(p.sizeof_argument_types), 1, fin);
    if (p.sizeof_argument_types) 
	p.argument_types = (unsigned short *) xalloc(p.sizeof_argument_types);

    fread((char *) p.argument_types,
	  sizeof(char), p.sizeof_argument_types, fin);
    
    fread((char *) &ino, sizeof(ino), 1, fin);
    if (ino) 
    {
	/* CHECK THIS PART !!!!!!!!!!!!!!!!!!!!!!!!! pointers or 16 bit ??? */
	p.type_start = (unsigned short *)
	    xalloc(sizeof(unsigned short) * p.num_functions);
	fread((char *) &p.type_start,
	      sizeof(unsigned short) * p.num_functions, 1, fin);
    } 
    
    fread((char *) &p.num_strings,sizeof(p.num_strings), 1, fin);
    if (p.num_strings) p.strings=
	(char **) xalloc(sizeof(char *) * p.num_strings);

    for(i = 0; i < (int)p.num_strings; i++) 
    {
	fread((char *) &ino, sizeof(ino), 1, fin);
	ALLOCATE_BUF(ino + 1);
	fread(buf, sizeof(char), ino, fin);
	buf[ino] = '\000';
	p.strings[i] = make_shared_string(buf);
    }
    
    fread((char *) &p.num_variables, sizeof(p.num_variables), 1, fin);

    if (p.num_variables) 
	p.variable_names = 
	    (struct variable *) xalloc(sizeof(struct variable) *
				       p.num_variables);

    for(i = 0; i < (int)p.num_variables; i++)
    {
	fread((char *) &ino, sizeof(ino), 1, fin);
	ALLOCATE_BUF(ino + 1);
	fread(buf, sizeof(char), ino, fin);
	buf[ino] = '\000';
	p.variable_names[i].name = make_shared_string(buf);
	fread((char *) &p.variable_names[i].type,
	      sizeof(p.variable_names[i].type), 1, fin);
    }
    
    fread((char *) &p.num_inherited, sizeof(p.num_inherited), 1, fin);
    if (p.num_inherited) p.inherit=(struct inherit *)
	xalloc(sizeof(struct inherit) * p.num_inherited);

    for(i = 0; i < (int)p.num_inherited; i++)
    {
	
	fread((char *) &ino, sizeof(ino), 1, fin);
	ALLOCATE_BUF(ino + 1);
	fread(buf,sizeof(char),ino,fin);
	buf[ino] = '\000';
	p.inherit[i].prog = (struct program *) string_copy(buf);
	fread((char *) &p.inherit[i].type,
	      sizeof(p.inherit[i].type), 1, fin);
	fread((char *) &p.inherit[i].variable_index_offset,
	      sizeof(p.inherit[i].variable_index_offset), 1, fin);
	fread((char *) &ino, sizeof(ino), 1, fin);
	ALLOCATE_BUF(ino + 1);
	fread(buf, sizeof(char), ino, fin);
	buf[ino] = '\000';
	p.inherit[i].name = make_shared_string(buf);
    }
    free((char*)p.inherit[p.num_inherited - 1].prog);
    
    fread((char *) &p.total_size, sizeof(p.total_size), 1, fin);

    fread((char *) &p.sizeof_include_files,
	  sizeof(p.sizeof_include_files), 1, fin);
    if (p.sizeof_include_files) 
    {
	p.include_files = xalloc(p.sizeof_include_files);
	fread(p.include_files, sizeof(char), p.sizeof_include_files, fin);
    }
    free(buf);
    buf = 0;

    fread((char *)&p.mod_time, sizeof(p.mod_time), 1, fin);

    loaded_size = ftell(fin) - loaded_size;
    fclose(fin);
    
    /* Now set up the program */

    /* now check if the inherited programs exist! */
    
    for(i = 0; i < (int)p.num_inherited - 1; i++) 
    {
        extern struct object *find_object_no_create();
        char *name = strchr((char *)p.inherit[i].prog, ':') + 1;
        int age = atoi((char *)p.inherit[i].prog);
        if (!name) 
            fatal("BINARIES CAN NOT SEPARATE AGE & NAME %s!\n",
		  p.name);
        tmpo = find_object_no_create(name);
        if (!tmpo)
	{
	    int j;
            for(j = i; j < (int)p.num_inherited - 1; j++)
                free((char*) p.inherit[j].prog);
            drop_prog(&p);
            return LIB_YOUNG_INHERIT;
        }

        if (tmpo->prog->mod_time != age)
        {
            int j;
            if (comp_flag)
            {
                fprintf(stderr,"LIB_BLIB Inherited object changed (%s->%s)\n",
                        p.name, name);
                fprintf(stderr,"Inherited object was: %s\n", tmpo->prog->name);
            }
            for(j = i; j < (int)p.num_inherited - 1; j++)
                free((char*) p.inherit[j].prog);
            drop_prog(&p);
            return LIB_YOUNG_INHERIT;
        }
        free((char*)p.inherit[i].prog);
        p.inherit[i].prog = tmpo->prog;
    }

    /* now comes an check of the ages of all INCLUDED files: */
    if (p.sizeof_include_files) 
    {
	struct stat stb;
	int age;
	char *t, *tmp = xalloc(p.sizeof_include_files);
	memcpy(tmp, p.include_files, p.sizeof_include_files);
	t = tmp;
	while(t < tmp + p.sizeof_include_files) 
	{
	    age = atoi(t);
	    t = strchr((char *) t, ':');
	    if (!t)
		fatal("LIB_BLIB_LOAD CAN NOT SEPARATE AGE & INAM %s!\n",
		      p.name);
	    else
		t++;
	    if (stat(t, &stb) == -1) 
	    {
		if (comp_flag)
		    fprintf(stderr,
			    "LIB_BLIB Included file not found %s->%s)\n",
			    p.name, t);
		drop_prog(&p);
		free(tmp);
		return LIB_BAD_INCLUDE;
	    }
	    if (stb.st_mtime != age)
	    {
		if (comp_flag)
		    fprintf(stderr,"LIB_BLIB Included file changed (%s->%s)\n",
			    p.name, t);
		drop_prog(&p);
		free(tmp);
		return LIB_YOUNG_INCLUDE;
	    }
	    t = strchr((char *) t, '\000') + 1;
	}
	free(tmp);
    }
    my_memsize =  align(sizeof(struct program));
    my_pmemsize = align(p.program_size);
    my_memsize += align(p.num_functions * sizeof(struct function));
    my_pmemsize += align(sizeof(char *) * p.num_strings);
    my_memsize += align(p.num_variables * sizeof(struct variable));
    my_memsize += align(p.num_inherited * sizeof(struct inherit));
    
    my_memsize += align(p.sizeof_argument_types);
    if (p.type_start)
	my_memsize += align(sizeof(unsigned short) * p.num_functions);

    my_memsize += align(p.sizeof_include_files);
   
    prog = (struct program *) xalloc(my_memsize);
    *prog = p;

    prog->total_size = my_memsize;
    
    tp = (char *)prog + align(sizeof(struct program));
    if (p.program)
    {
	prog->program = (char *) memcpy(xalloc(my_pmemsize), p.program, p.program_size);
	free((char*) p.program);
    }
    if (p.functions)
    {
	prog->functions = (struct function *)tp;
	hash_functions(p.num_functions, p.functions, prog->functions);
	
	free((char*) p.functions);
	tp += align(p.num_functions * sizeof(struct function));
    }
    if (p.strings)
    {
	prog->strings = (char **)
	    memcpy(prog->program + align(prog->program_size),
                   p.strings, sizeof(char *) * p.num_strings);
	free((char*)p.strings);
    }
    if (p.variable_names)
    {
	prog->variable_names = (struct variable *) memcpy(tp, p.variable_names,
						       p.num_variables * sizeof(struct variable));
	free((char*)p.variable_names);
	tp += align(p.num_variables*sizeof(struct variable));
    } 
    if (p.inherit) 
    {
	prog->inherit=(struct inherit *)memcpy(tp,p.inherit,
					       p.num_inherited*sizeof(struct inherit));
	free((char*)p.inherit);
	tp += align(p.num_inherited*sizeof(struct inherit));
    }
    prog->inherit[prog->num_inherited - 1].prog = prog;
    
    if (p.argument_types)
    {
	prog->argument_types = (unsigned short *) memcpy(tp,p.argument_types,
						      p.sizeof_argument_types);
	free((char*)p.argument_types);
	tp += align(p.sizeof_argument_types);
    }
    if (p.type_start)
    {
	prog->type_start=(unsigned short *) memcpy(tp, p.type_start,
						  p.num_functions * sizeof(unsigned short));
	free((char*) p.type_start);
	tp += align(p.num_functions * sizeof(unsigned short));
    }

    if (p.include_files) 
    {
	prog->include_files = (char *) memcpy(tp, p.include_files,
					   p.sizeof_include_files);
	free((char *) p.include_files);
	tp += align(p.sizeof_include_files);
    }

    {
	extern int current_id_number; /* from prelang.y (argl) */
	prog->id_number = current_id_number++;
    }

    prog->inherit[prog->num_inherited - 1].prog = prog;
    for(i = 0; i < (int)prog->num_inherited; i++)
	reference_prog(prog->inherit[i].prog, "BLIB_inheritance");
    
    look_for_heart_beat(prog);

    total_prog_block_size += prog->total_size;
    total_program_size += my_pmemsize;
    
    total_num_prog_blocks += 1;

    if (process_reloc(prog, 0, 1) || link_C_functions(prog))
	return free_prog(prog, 1),2;
    swap_lineno(prog);
    
    return LOAD_OK;
}
FILE *crdir_fopen(name)
    char *name;
{
    char ch, *p, *cname = string_copy(name);
    int len, pos;
    struct stat c_st;

    len = strlen(cname);
    p = cname;

    while (*p)
    {
	while (*p && *p != '/') p++;
	ch = *p;
	*p = 0;
	if (stat(cname, &c_st) == -1 &&
	    ch == '/')
	{
	    /* We must create this dir
            */
	    if (mkdir(cname, 0774) == -1)
	    {
		free((char*) cname);
		return (FILE *) 0;
	    }
	}
	*p = ch;
	if (ch == '/')
	    p++;
    }
    free((char*) cname);

    return fopen(name, "w");
}
#endif
