
#include "interface.h"

extern struct interface efun;
extern struct interface stdobject;
extern struct interface gl_language;

struct interface *(interface[]) = 
{
    &efun,
    &stdobject,
    &gl_language,
    (struct interface *)0,
};


void (*
get_C_fun_address(char *prog_name, char *name))()
{
    int i, j;
    for(i = 0; interface[i]; i++)
	if (!strcmp(interface[i]->program, prog_name))
	    for(j = 0; interface[i]->funcs[j]; j++)
		if (!strcmp(interface[i]->funcs[j]->name, name))
		    return interface[i]->funcs[j]->address;
    
    return (void (*)())0;
}

int
link_C_functions(struct program *prog)
{
    int i, j, errors = 0;
    for(i = 0; interface[i]; i++)
	if (!strcmp(interface[i]->program,prog->name))
	    for(j = 0; interface[i]->vars[j]; j++)
		{
		    if (find_status(prog, interface[i]->vars[j]->name, 0) == -1)
			errors++;
		    interface[i]->vars[j]->var_index = variable_index_found;
		    interface[i]->vars[j]->var_inherit = variable_inherit_found;
		}
    return errors;
}
