#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/socket.h>
#ifdef AUTHORIZE
#include <ident.h>
#include <sys/time.h>
#endif

int
main(int argc, char *argv[])
{
    char buf[80];
    unsigned long addr;
    struct hostent *hp;
#ifdef AUTHORIZE
    struct sockaddr_in laddr, faddr;
    int lport, fport, lp, fp;
    struct timeval timeout;
    ident_t *id;
    char *p, *ident, *opsys, *cset;

/*fprintf(stderr, "hname starts\n");*/
    if (argc == 2)
	lport = atoi(argv[1]);
    else
	lport = 0;
    timeout.tv_sec = 30;
    timeout.tv_usec = 0;
    bzero(&laddr, sizeof(laddr));
    laddr.sin_addr.s_addr = INADDR_ANY;
#endif
    printf("\n");
    fflush(stdout);
    for(;;) {
	if (gets(buf) == NULL)
	    break;
/*fprintf(stderr, "hname got %s\n", buf);*/
	addr = inet_addr(buf);
#ifdef AUTHORIZE
	ident = NULL;
	p = strchr(buf, ' ');
	if (p)
	    fport = atoi(p + 1);
	else
	    fport = 0;
#endif
	if (addr != -1) {
	    hp = gethostbyaddr((char *)&addr, 4, AF_INET);
#ifdef AUTHORIZE
	    if (lport && fport && (p = strchr(buf, ' ')) != NULL) {
		bzero(&faddr, sizeof(faddr));
		faddr.sin_addr.s_addr = addr;

		id = id_open(&laddr.sin_addr, &faddr.sin_addr, &timeout);
		if (id && id_query(id, fport, lport, &timeout) < 1) {
		    id_close(id);
		    id = NULL;
		}
		if (id && id_parse(id, &timeout, &fp, &lp, &ident, &opsys, &cset) != 1) {
		    id_close(id);
		    id = NULL;
		}
		if (id) {
		    id_close(id);
		    free(opsys);
		    free(cset);
		}
		if (ident && strcmp(ident, "UNKNOWN-ERROR") == 0) {
		    free(ident);
		    ident = NULL;
		}
	    }
#endif
	    if (!hp) {
		sleep(5);
	        hp = gethostbyaddr((char *)&addr, 4, AF_INET);
	    }
	    if (hp) {
/*fprintf(stderr, "hname sends %s...", hp->h_name);*/
#ifdef AUTHORIZE
		if (ident) {
		    printf("%s %s@%s\n", buf, ident, hp->h_name);
		    free(ident);
		    ident = NULL;
		}
		else
#endif
		    printf("%s %s\n", buf, hp->h_name);
		fflush(stdout);
/*fprintf(stderr, "done\n");*/
	    }
#ifdef AUTHORIZE
	    else if (ident) {
		printf("%s %s@\n", buf, ident);
		fflush(stdout);
		free(ident);
		ident = NULL;
	    }
#endif
	}
    }
/*fprintf(stderr, "hname exits\n");*/
}
